﻿var app = window.app = window.app || {};
app.vm = app.vm || {};

app.vm.request = function () {
    var self = this;

    self.foreign = ko.observable();
    self.datasetId = ko.observable();
    self.datasetCaption = ko.observable();
    
    self.datasetrowNumber = ko.observable();

    self.userSurname = ko.observable();
    self.userName = ko.observable();
    self.userPatronymic = ko.observable();
    
    self.userEmail = ko.observable();
    self.userPhone = ko.observable();
    
    self.problem = ko.observable("data_3");
    self.problems = [
        { id: 0, name: 'Некорректность значений атрибутов объекта в наборе данных', englishName:'Incorrect dataset attributes values', caption: "data_3"},
        { id: 1, name: 'Отсутствие существующего объекта в наборе данных', englishName: 'Existing dataset object is missing', caption: "data_1" },
        { id: 2, name: 'Наличие несуществующего объекта в наборе данных', englishName: 'Nonexisting object is presented', caption: "data_2" }];

    self.comment = ko.observable();

    self.addComment = function (el) {
        self.datasetrowNumber(el.Number);
        showCommentWind();
    };
    self.requestOutput = ko.observable();
    self.toJS = function () {
        return {
            DatasetId: self.datasetId(),
            DatasetrowNumber: self.datasetrowNumber(),
            UserSurname: self.userSurname(),
            UserName: self.userName(),
            UserPatronymic: self.userPatronymic(),
            UserEmail: self.userEmail(),
            UserPhone: self.userPhone(),
            Problem: $('[data-bind*="problem"] option:selected').text(),//self.problem(),
            Comment: self.comment()
        };
    };
    self.clearModel = function () {
        self.datasetId(null);
        self.datasetrowNumber(null);
        self.userSurname(null);
        self.userName(null);
        self.userPatronymic(null);
        self.userEmail(null);
        self.userPhone(null);
        self.problem(null);
        self.comment(null);
    };
    self.send = function (el) {
        if (self.userSurname() == '' || self.userName() == '' || self.comment() == '' || self.userEmail() == '' || self.userSurname() == undefined || self.userName() == undefined || self.comment() == undefined || self.userEmail() == undefined) {
            if (self.foreign()) {
                toastr.warning('Fields marked with asterisk are required.');
                //alert('Fields marked with asterisk are required.');
            } else {
                toastr.warning('Заполните поля, отмеченные звездочкой.');
                //alert('Заполните поля, отмеченные звездочкой.');
            }
            
        }
        else {
            if (self.problem() == "data_1") {
                self.datasetrowNumber(0);
            }
            $.ajax({
                url: app.root + 'api/Requests/Post',
                type: 'POST',
                data: JSON.stringify(self.toJS()),
                contentType: 'application/json; charset=utf-8',
                success: function (par) {
                    //self.requestOutput(par);
                    if (self.foreign()) {
                        //if (self.requestOutput() == null) {
                        //    toastr.error('The request was not created!');
                        //    //alert('The request was not created!');
                        //}
                        //else {
                        self.clearModel();
                        toastr.success('The request was created!');
                        	//toastr.success('The request was created! Request number: ' + self.requestOutput());
                            //alert('The request was created! Request number: ' + self.requestOutput());
                        //}
                    } else {
                        //if (self.requestOutput() == null) {
                        //    toastr.error('Обращение не было создано!');
                        //    //alert('Обращение не было создано!');
                        //}
                        //else {
                        self.clearModel();
                        	toastr.success('Обращение создано!');
                            //toastr.success('Обращение №' + self.requestOutput() + ' создано!');
                            //alert('Обращение №' + self.requestOutput() + ' создано!');
                        //}
                    }
                    

                    
                }
            });
            //send
            hideCommentWind();
            self.comment('');
        }
    };
};

app.request = new app.vm.request;

function showCommentWind() {
    $(".overlay").css({
        'display': 'block'
    });
    $("#requestCreation").css({
        'display': 'block'
    });
};
function hideCommentWind() {
    $(".overlay").css({
        'display': 'none'
    });
    $("#requestCreation").css({
        'display': 'none'
    });
};

function displayCommentButton() {
    $("requestCreationButton").css({
        'display': 'block'
    });
};