/*
Автор: Пучкин В.
puchkin@prognoz.ru
*/

// скрипт используется для стилизации чекбоксов
jQuery.fn.checkbox = function()
{
	$(this).each(function()
	{
		$(this).css('opacity', '0');
		$(this).closest('div').prepend('<div class="fake_checkbox"></div>');
		//При загрузке
		if($(this).is(':checked'))
		{
			$(this).prev('.fake_checkbox').addClass('checked');
		}
		else
		{
			$(this).prev('.fake_checkbox').removeClass('checked');
		}
		//При клике
		$(this).live('click', function()
		{
			if($(this).is(':checked'))
			{
				$(this).prev('.fake_checkbox').addClass('checked');
			}
			else
			{
				$(this).prev('.fake_checkbox').removeClass('checked');
			}
		});
		//При наведении
		$(this).live('mouseover', function()
		{
			$(this).prev('.fake_checkbox').addClass('hover');
		}).live('mouseleave', function()
		{
			$(this).prev('.fake_checkbox').removeClass('hover');
		});
	});
}