﻿var app = window.app = window.app || {};
app.vm = app.vm || {};

app.vm.call = function () {
    var self = this;

    self.foreign = ko.observable();
    self.sessionId = ko.observable();
    self.RequestId = ko.observable();
    self.datasetCaption = ko.observable();

    self.userSurname = ko.observable();
    self.userName = ko.observable();
    self.userPatronymic = ko.observable();
    
    self.userEmail = ko.observable();
    self.userPhone = ko.observable();
    
    self.typeOfCall = ko.observable();
    self.comment = ko.observable();
    self.problem = ko.observable();

    self.addIdea = function (el) {
    	showCommentWind();
    	$("#callType").text("Идея");
    	self.problem("idea");
    };
    self.addRemark = function (el) {
    	showCommentWind();
    	$("#callType").text("Замечание");
    	self.problem("remark");
    };
    self.addQuestion = function (el) {
    	showCommentWind();
    	$("#callType").text("Вопрос");
    	self.problem("");
    };
    self.like = function (id) {
    	$("#spanLike_" + id).addClass("btnlike");
    	$("#spanDislike_" + id).removeClass("btndislike");

    	var vote = {
    		RequestId: id,
    		Voice: 1,
    		SessionId: self.sessionId()
    	};

    	$.ajax({
    		url: app.root + 'api/SupportRequests/Vote',
    		type: 'POST',
    		data: JSON.stringify(vote),
    		contentType: 'application/json; charset=utf-8',
    		success: function (par) {
    			if (par == "") {
    				toastr.success('Ваш голос учтён!');
    			}
    			else {
    				toastr.warning(par);
    			}
    		}
    	});
    };
    self.dislike = function (id) {
    	$("#spanLike_" + id).removeClass("btnlike");
    	$("#spanDislike_" + id).addClass("btndislike");

    	var vote = {
    		RequestId: id,
    		Voice: -1,
    		SessionId: self.sessionId()
    	};

    	$.ajax({
    		url: app.root + 'api/SupportRequests/Vote',
    		type: 'POST',
    		data: JSON.stringify(vote),
    		contentType: 'application/json; charset=utf-8',
    		success: function (par) {
    			if (par == "") {
    				toastr.success('Ваш голос учтён!');
    			}
    			else {
    				toastr.warning(par);
    			}
    		}
    	});
    };
    self.toJS = function () {
		return {
			DatasetCaption: self.datasetCaption(),
			UserSurname: self.userSurname(),
			UserName: self.userName(),
			UserPatronymic: self.userPatronymic(),
			UserEmail: self.userEmail(),
			UserPhone: self.userPhone(),
			Problem: self.problem(),
			Comment: self.comment(),
			SessionId: self.sessionId()
		};
	};

    self.send = function (el) {
        if (self.userSurname() == '' || self.userName() == '' || self.comment() == '' || self.userEmail() == '' || self.userSurname() == undefined || self.userName() == undefined || self.comment() == undefined || self.userEmail() == undefined) {
            if (self.foreign()) {
                toastr.warning('Fields marked with asterisk are required.');
            } else {
                toastr.warning('Заполните поля, отмеченные звездочкой.');
            }
            
        }
        else {
        	var data = self.toJS();
            $.ajax({
            	url: app.root + 'api/SupportRequests/Post',
            	type: 'POST',
            	content: data,
                data: JSON.stringify(data),
                contentType: 'application/json; charset=utf-8',
                success: function (par) {
					var data = this.content;
					$.ajax({
            			url: app.root + 'api/SupportRequests/SendTo',
						type: 'POST',
						data: JSON.stringify(data),
						contentType: 'application/json; charset=utf-8',
						success: function (result) {
							if (self.foreign()) {
								toastr.success('The request was created!');
							} else {
								toastr.success('Обращение создано!');
							}
                			setInterval(obnovit_stranicu, 2500);
						}
					});
                }
            });//*/
            hideCommentWind();
            self.comment('');
        }
    };

    function obnovit_stranicu() {
    	location.reload();
    }
};

app.call = new app.vm.call;

function showCommentWind() {
	$(".overlay").css({
        'display': 'block'
    });
    $("#callCreation").css({
        'display': 'block'
    });
};
function hideCommentWind() {
	$(".overlay").css({
        'display': 'none'
    });
    $("#callCreation").css({
        'display': 'none'
    });
};

function displayCommentButton() {
	$("callCreationIdea").css({
        'display': 'block'
    });
};