﻿/*Array.prototype.remove = function(el) {
    return this.splice(this.indexOf(el), 1);
};
*/
Array.prototype.Where = function (prop, val) {
    var result = [];
    if (typeof prop == "function") {
        for (var i = 0; i < this.length; i++) {
            if (prop(this[i])) {
                result.push(this[i]);
            }
        }
    } else {
        for (var i = 0, l = this.length; i < l; i++) {
            if (this[i][prop] === val) {
                result.push(this[i]);
            }
        }
    }
    return result;
};
Array.prototype.GroupBy = function (prop) {
    var result = [];
    for (var i = 0, l = this.length; i < l; i++) {
        if (!result[this[i][prop]]) {
            result[this[i][prop]] = [];
        }
        result[this[i][prop]].push(this[i]);
    }
    return result;
};
Array.prototype.filter = function (prop, vals) {
    prop = prop || 'Id';
    var res = [];
    if (typeof prop == "function") {
        for (var i = 0, l = this.length; i < l; i++) {
            if (prop(this[i])) {
                res.push(this[i]);
            }
        }
    } else {
        vals.constructor !== Array && (vals = [vals]);
        for (var i = 0, l = this.length; i < l; i++) {
            for (var j = 0, len = vals.length; j < len; j++) {
                if (this[i][prop] == vals[j]) {
                    res.push(this[i]);
                }
            }
        }
    }
    return res;
};

Array.prototype.first = function (lambda) {
    if (typeof lambda == 'function') {
        for (var i = 0, l = this.length; i < l; i++) {
            if (lambda(this[i])) {
                return this[i];
            }
        }
    }
    return null;
};

Array.prototype.initMap = function () {
    this['map'] = [];
    for (var i = 0; i < this.length; i++) {
        this['map'][this[i].Id] = this[i];
    }
};

Array.prototype.Max = function (prop) {
    var result = this[0];
    if (prop && result[prop] !== 'undefined') {
        result = result[prop];
        for (var i = 0, l = this.length; i < l; i++) {
            result < this[i][prop] && (result = this[i][prop]);
        }
        return result;
    }
    for (var i = 0, l = this.length; i < l; i++) {
        result < this[i] && (result = this[i]);
    }
    return result;
};
Array.prototype.Min = function (prop) {
    var result = this[0];
    if (prop && result[prop] !== 'undefined') {
        result = result[prop];
        for (var i = 0, l = this.length; i < l; i++) {
            result > this[i][prop] && (result = this[i][prop]);
        }
        return result;
    }
    for (var i = 0, l = this.length; i < l; i++) {
        result > this[i] && (result = this[i]);
    }
    return result;
};

Array.prototype.Sum = function (lambda) {
    var sum = 0;
    for (var i = 0; i < this.length; i++) {
        if (lambda(this[i])) {
            sum += lambda(this[i]);
        }
    }
    return sum;
};

String.prototype.Format = function () {
    var result = this.valueOf();
    if (arguments.length > 0) {
        for (var i = 0, l = arguments.length; i < l; i++) {
            if (typeof arguments[i] === "string" || typeof arguments[i] === "number") {
                result = result.replace(new RegExp('\\{' + i + '\\}', "g"), arguments[i]);
            }
        }
    }
    return result;
};

String.prototype.parseDate = function (offset) {
    try {
        var d = eval(this.replace(/\/(Date\([0-9-]+\))\//gi, "new $1")),
            utc = d.getTime() + (d.getTimezoneOffset() * 60000);
        offset = offset || 0;
        return new Date(utc + (3600000 * offset));
    } catch (e) {
        return null;
    }
};