﻿//Слайдер на главной (код предыдущего разработчика)
/*var datamos = (function () {
    var pub = {};

    pub.carousel = [];
    pub.currentItem = 0;

    pub.startCarousel = function() {
        $('.carousel_wrapper .item').each(function(i) {
            pub.carousel[i] = $(this);
            $(this).hide();
        });
        if (pub.carousel.length)
            pub.carousel[pub.currentItem].show();
        $('.carousel_wrapper .left').click(pub.moveCarouselLeft);
        $('.carousel_wrapper .right').click(pub.moveCarouselRight);
    };
    pub.moveCarouselLeft = function() {
        pub.moveCarousel(-1);
        return false;
    };
    pub.moveCarouselRight = function() {
        pub.moveCarousel(1);
        return false;
    };
    pub.moveCarousel = function(dir) {
        var nextItem = pub.currentItem + dir;
        if (nextItem < 0)
            nextItem += pub.carousel.length;
        nextItem %= pub.carousel.length;
        pub.carousel[nextItem].css('left', 700 * dir);
        pub.carousel[nextItem].show();
        pub.carousel[nextItem].animate({ 'left': 0 }, 1000);
        pub.carousel[pub.currentItem].animate({ 'left': 700 * dir * -1 }, 1000);
        pub.currentItem = nextItem;
    };

    return pub;
}()); */

// дополнительные скрипты

function scrollWidthTable() {

	$('.scroll_with_table').css({

		'width': $('.content').width() - 300

	});

}

function minHeightContent() {

	$('.content').css({

		'min-height': $(window).height() - $('.header').innerHeight() - $('.menu').innerHeight() - $('.footer').innerHeight() - 55

	});

	if ($('.home_slider').length > 0) {

		$('.content').css({

			'min-height': parseInt($('.content').css('min-height')) - $('.home_slider').innerHeight() - 18

		});

	}

}

//При загрузке страницы
$(document).ready(function () {

	/*
		Combobox
	*/
	if ($('.combobox').length > 0) {

		$('.combobox').linbox({
			select: 'single',
			selectClearText: '',
			closingWhenClick: true
		});
	}

	/*
		checkbox
	*/

	if ($('input[type="checkbox"]').length > 0) {

		$('input[type="checkbox"]').checkbox();

	}

	/*
		Slider
	*/
	$('.slider_right').on('click', function () {

		var checkSlider = $('.slider table').innerWidth() + parseInt($('.slider table').css('margin-left'));

		if (checkSlider - $('.slider').innerWidth() > $('.slider table td').innerWidth()) {

			if (!$('.slider table').hasClass('active')) {

				$('.slider table').addClass('active').animate({
					'margin-left': parseInt($('.slider table').css('margin-left')) - $('.slider table td').innerWidth()
				}, function () {
					$('.slider table').removeClass('active');
				});

			}

		} else {

			if (!$('.slider table').hasClass('active')) {

				$('.slider table').addClass('active').animate({
					'margin-left': -1 * ($('.slider table').innerWidth() - $('.slider').innerWidth())
				}, function () {
					$('.slider table').removeClass('active');
				});

			}

		}

	});

	$('.slider_left').on('click', function () {

		var slideLeftCount = parseInt($('.slider table').css('margin-left')) + $('.slider table td').innerWidth()

		if (slideLeftCount < 0) {

			if (!$('.slider table').hasClass('active')) {

				$('.slider table').addClass('active').animate({
					'margin-left': slideLeftCount
				}, function () {
					$('.slider table').removeClass('active');
				});

			}

		} else {

			if (!$('.slider table').hasClass('active')) {

				$('.slider table').addClass('active').animate({
					'margin-left': 0
				}, function () {
					$('.slider table').removeClass('active');
				});

			}

		}

	});

	/*
		All check right menu
	*/
	$('.right_all_check').on('click', function () {

		var _this = $(this),
			_thisId = _this.attr('id');


		$('*[data-attr-check=' + _thisId + ']').find('.checkbox_container').each(function () {

			if (!$(this).find('.fake_checkbox').hasClass('checked')) {

				$(this).find('.fake_checkbox').addClass('checked');
				$(this).find('input[type="checkbox"]').attr('checked', 'checked');

			}

		});

	});

	/*
		To hide the block
	*/
	$('.hide_block_btn').on('click', function () {

		var _this = $(this),
			parent = _this.closest('.hide_block'),
			content = parent.find('.hide_block_content');

		if (!parent.hasClass('hide-active')) {

			parent.addClass('hide-active');
			content.slideUp();
			_this.text(_this.attr('data-hide-text'));

		} else {

			parent.removeClass('hide-active');
			content.slideDown();
			_this.text(_this.attr('data-show-text'));

		}

	});

	/*
		Width scroll_with_table
	*/
	setTimeout(scrollWidthTable, 100);
	minHeightContent();


});

//При ресайзе страницы
$(window).resize(function () {

	scrollWidthTable();
	minHeightContent();

});

//



//При выводе datasets
function generateDate(date) {
    return new Date(date.substr(6, 4), date.substr(3, 2), date.substr(0, 2), date.substr(11, 2), date.substr(14, 2), date.substr(17, 2));
}

function toSortDateByDesc(a, b) {
    var strA = $(a).attr('data-date');
    var strB = $(b).attr('data-date');
    var dA = generateDate(strA);
    var dB = generateDate(strB);
    return (dA > dB) ? -1 : (dA < dB) ? 1 : 0;
}
function toSortDateByAsc(a, b) {
    var strA = $(a).attr('data-date');
    var strB = $(b).attr('data-date');
    var dA = generateDate(strA);
    var dB = generateDate(strB);
    return (dA > dB) ? 1 : (dA < dB) ? -1 : 0;
}
function toSortCaptionByDesc(a, b) {
    var strA = $(a).attr('data-caption');
    var strB = $(b).attr('data-caption');
    return (strA > strB) ? -1 : (strA < strB) ? 1 : 0;
}
function toSortCaptionByAsc(a, b) {
    var strA = $(a).attr('data-caption');
    var strB = $(b).attr('data-caption');
    return (strA > strB) ? 1 : (strA < strB) ? -1 : 0;
}


function sortDatasets(id) {
    ($('#' + id).attr('data-sorted') == 'desc') ? $('#' + id).attr('data-sorted', 'asc') : $('#' + id).attr('data-sorted', 'desc');
    //для регистра
    if (id.indexOf('reg') >= 0) {
        if (id.substr(0, 1) == 'c') {
            $('#' + id).attr('data-sorted') == 'desc'? $('tbody tr').sort(toSortCaptionByAsc).appendTo('#register'):$('tbody tr').sort(toSortCaptionByDesc).appendTo('#register');
        }
        else {
            $('#' + id).attr('data-sorted') == 'desc'? $('tbody tr').sort(toSortDateByAsc).appendTo('#register'):$('tbody tr').sort(toSortDateByDesc).appendTo('#register');
            }
    }
    //для категорий
    else {
        var sect = $('#' + id).parent().parent();
        if (id.substr(0, 1) == 'c') {
            $('#' + id).attr('data-sorted') == 'desc'?sect.children('a.ico_item').sort(toSortCaptionByAsc).appendTo('#' + sect.attr('id')):sect.children('a.ico_item').sort(toSortCaptionByDesc).appendTo('#' + sect.attr('id'));
        }
        else {
            $('#' + id).attr('data-sorted') == 'desc'?sect.children('a.ico_item').sort(toSortDateByAsc).appendTo('#' + sect.attr('id')):sect.children('a.ico_item').sort(toSortDateByDesc).appendTo('#' + sect.attr('id'));
      

        }
    }

}

function checkingHeader() {
    if ($('#ch_all').attr('checked') == 'checked') {
        $('.menu_left').children('input:checkbox').attr('checked', true);
    }
    else {
        $('.menu_left').children('input:checkbox').attr('checked', false);
    }

}
function checkingAll() {
    var ch = $('.menu_left').children('input:checkbox');
    var allChecked = true;
    for (var i = 0; i < ch.length; i++) {
        if (ch[i].checked == false) {
            allChecked = false;
        }
    }
    if (allChecked) {
        $('#ch_all').attr('checked', true);
    }
    else {
        $('#ch_all').attr('checked', false);
    }
}